using System;
using System.Linq;
using System.Text;
using DevExpress.Xpo;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.DC;
using DevExpress.Data.Filtering;
using DevExpress.Persistent.Base;
using System.Collections.Generic;
using DevExpress.ExpressApp.Model;
using DevExpress.Persistent.BaseImpl;
using DevExpress.Persistent.Validation;
using Xafari.BC.Xpo;

namespace SampleDynamicProperties.Module.BusinessObjects
{
    [DefaultClassOptions]
    public class CustomerXpo : PersistentXafariBaseObject
    {
        public CustomerXpo(Session session) : base(session) { }
        private string _name;
        private string _address;

        public string Name
        {
            get { return _name; }
            set { SetPropertyValue("Name", ref _name, value); }
        }

        public string Address
        {
            get { return _address; }
            set { SetPropertyValue("Address", ref _address, value); }
        }
    }
}
